//+------------------------------------------------------------------+
//|                                           WPR Strength Arrow.mq4 |
//|                                      Copyright  2016, Crossluck |
//|                                                       20/05.2016 |
//|           : http://forexsystemsru.com/member.php?u=118325 |
//|            email: krokhin.roman.91@lenta.ru | skype: crossing203 |
//+------------------------------------------------------------------+
#property strict
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_width1 2
#property indicator_color2 Red
#property indicator_width2 2
extern string S1="  WPR";
extern int period=14;//
extern string S2="   WPR";
extern double level_1=-20;// 
extern double level_2=-80;// 
extern string S3=" WPR";
extern bool wpr_filter=false;// WPR
extern int period_wpr_2=14;//
extern string S5="/";
extern bool ClearAllObjects=false;//    
extern int counted_bars=1000;// 
extern double indent=100;//
string LF="\n";
int ObjCount=0;
int current=0;
double up[];
double down[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
if(ClearAllObjects)ObjectsDeleteAll();
IndicatorShortName("WPR Strength Arrow");
IndicatorDigits(5);
IndicatorBuffers(2);
SetIndexBuffer(0,up);
SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID);
SetIndexArrow(0,225);
SetIndexBuffer(1,down);
SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID);
SetIndexArrow(1,226);
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
if(ClearAllObjects)ObjectsDeleteAll();
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator start function                                  |
//+------------------------------------------------------------------+
int start()
{
Tick();
return(0);
}
//+------------------------------------------------------------------+
void Tick()
{
for(int i=0;i<counted_bars;i++)
{
current=i;
up();
down();
}
}
void up()
{
if((iWPR(NULL,NULL,period,current+1)>level_1))
{
wpr_filter_up();
}
}
void wpr_filter_up()
{
if(!wpr_filter)arrow_up();
if((wpr_filter&&iWPR(NULL,0,period_wpr_2,current+1)>iWPR(NULL,0,period_wpr_2,current+2))&&(iWPR(NULL,0,period_wpr_2,current+1)>iWPR(NULL,0,period_wpr_2,current+3)))
{
arrow_up();
}
}
void arrow_up()
{
up[current]=Low[current]-indent*Point();
}
void down()
{
if((iWPR(NULL,NULL,period,current+1)<level_2))
{
wpr_filter_down();
}
}
void wpr_filter_down()
{
if(!wpr_filter)arrow_down();
if((wpr_filter&&iWPR(NULL,0,period_wpr_2,current+1)<iWPR(NULL,0,period_wpr_2,current+2))&&(iWPR(NULL,0,period_wpr_2,current+1)<iWPR(NULL,0,period_wpr_2,current+3)))
{
arrow_down();
}
}
void arrow_down()
{
down[current]=High[current]+indent*Point();
}